package com.perfectech.cts;

import android.content.Context;
import android.util.Log;

import com.perfectech.cts.objects.Jobs;

import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by jcairns on 6/19/15.
 */
public class JobClass {
    private static final String sDBName = "CTS.db";
    public Context oContext;
    private static ArrayList<ArrayList<String>> jobArray;
    static int iVersionVal = 6;

    public ArrayList<Jobs> read() {
        ArrayList<Jobs> oRtnVal = new ArrayList<Jobs>();

        CTSDBHelper oDB = new CTSDBHelper(oContext, sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sSQL = "Select * ";
            sSQL += "from Jobs ";
            sSQL += "where job_status_id =  4";

            Log.d("sSQL", sSQL);

            jobArray = oDB.selectRecordsFromDBList(sSQL, null);
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        } finally {
            // closes the database
            try {
                oDB.close();
            } catch (Throwable e) {
                e.printStackTrace();
            }
        }

        if (jobArray.size() > 0) {
            for (ArrayList<String> sValue : jobArray) {
                Jobs oJob = new Jobs();
                oJob.job_id = sValue.get(1);
                oJob.date_time = sValue.get(2);
                oJob.job_status_id = sValue.get(3);
                oJob.status_name = sValue.get(4);
                oJob.assigned_id = sValue.get(5);
                oJob.manifest_num = sValue.get(6);
                oJob.container_num = sValue.get(7);
                oJob.delivery_address_line1 = sValue.get(8);
                oJob.delivery_address_line2 = sValue.get(9);
                oJob.delivery_city = sValue.get(10);
                oJob.delivery_state = sValue.get(11);
                oJob.delivery_postal_code = sValue.get(12);
                oJob.pickup_address_line1 = sValue.get(13);
                oJob.pickup_address_line2 = sValue.get(14);
                oJob.pickup_city = sValue.get(15);
                oJob.pickup_state = sValue.get(16);
                oJob.pickup_postal_code = sValue.get(17);
                oJob.username = sValue.get(18);
                oJob.importer_id = sValue.get(19);
                oJob.importer_name = sValue.get(20);
                oJob.job_num = sValue.get(21);
                oJob.pickup_date_time = sValue.get(22);
                oJob.delivery_date_time = sValue.get(23);
                oJob.ref_note = sValue.get(24);
                oRtnVal.add(oJob);
            }
        }

        return oRtnVal;
    }

    public boolean activeJob() {
        Boolean bRtnValue = false;
        CTSDBHelper oDB = new CTSDBHelper(oContext, sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();
        //Check for any Active
        String sSQL = "select * from jobs where job_status_id = 4";
        jobArray = oDB.selectRecordsFromDBList(sSQL, null);
        if (jobArray.size() > 0) {
            bRtnValue = true;
        }
        oDB.close();
        return bRtnValue;
    }

    public Jobs readWithPaused() {
        Jobs oRtnVal = new Jobs();

        CTSDBHelper oDB = new CTSDBHelper(oContext, sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();
        String sSQL = "Select * ";
        sSQL += "from Jobs ";
        sSQL += "where job_status_id in (3,4,5,8)"; //= 4 or job_status_id = 5";

        Log.d("sSQL", sSQL);

        jobArray = oDB.selectRecordsFromDBList(sSQL, null);

        // closes the database
        try {
            oDB.close();
        } catch (Throwable e) {
            e.printStackTrace();
        }
        if (jobArray.size() > 0) {
            for (ArrayList<String> sValue : jobArray) {
                oRtnVal.id = sValue.get(0);
                oRtnVal.job_id = sValue.get(1);
                oRtnVal.date_time = sValue.get(2);
                oRtnVal.job_status_id = sValue.get(3);
                oRtnVal.status_name = sValue.get(4);
                oRtnVal.assigned_id = sValue.get(5);
                oRtnVal.manifest_num = sValue.get(6);
                oRtnVal.container_num = sValue.get(7);
                oRtnVal.delivery_address_line1 = sValue.get(8);
                oRtnVal.delivery_address_line2 = sValue.get(9);
                oRtnVal.delivery_city = sValue.get(10);
                oRtnVal.delivery_state = sValue.get(11);
                oRtnVal.delivery_postal_code = sValue.get(12);
                oRtnVal.pickup_address_line1 = sValue.get(13);
                oRtnVal.pickup_address_line2 = sValue.get(14);
                oRtnVal.pickup_city = sValue.get(15);
                oRtnVal.pickup_state = sValue.get(16);
                oRtnVal.pickup_postal_code = sValue.get(17);
                oRtnVal.username = sValue.get(18);
                oRtnVal.importer_id = sValue.get(19);
                oRtnVal.importer_name = sValue.get(20);
                oRtnVal.job_num = sValue.get(21);
                oRtnVal.pickup_date_time = sValue.get(22);
                oRtnVal.delivery_date_time = sValue.get(23);
                oRtnVal.ref_note = sValue.get(24);
            }
        }

        return oRtnVal;
    }
}
